//----------------------------------------------------------------------------------
// aviutl GPU Lanczos TCYtB^
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>

#include <tchar.h>
#include <strsafe.h>

#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>

#include "filter.h"
#include "prof.h"
#include "gpufilter.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
GpuFilter *g_pGpuFilter = NULL;
bool g_chg_param = true;
bool g_need_realloc = true;

#define IDC_SETSIZE 1201
#define NUM_RSZ_MAX 8
WNDPROC g_orig_cmb_edit_proc = NULL;
HWND g_wbtn,g_wcmb,g_wedt;
HFONT g_font;

//ptH[}Xp
#ifdef PROFILE_GPU
HWND g_debugWindow = 0;
double g_QPFreq = 1.0;
PData g_prof;
bool g_flush = true;
#endif

//---------------------------------------------------------------------
// static func
//---------------------------------------------------------------------
static BOOL init_config_window(HWND hwnd, FILTER *fp);
static BOOL exit_config_window(HWND hwnd, FILTER *fp);
static BOOL set_rssize(HWND hwcmb, FILTER *fp);
static POINT get_edit_rssize(HWND hwcmb);
static void init_rss_list(HWND hwcmb, FILTER *fp);
static void ins_cmb_list(HWND hwcmb, int x, int y, bool sel);
static void save_rss_list(HWND hwcmb, FILTER *fp);
static LRESULT CALLBACK cmb_edit_proc(HWND h, UINT m, WPARAM w, LPARAM l);

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 3
enum { T_X, T_Y, T_RAD };
enum { C_PARA, C_FLUSH, C_U16 };

// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
LPSTR track_name[TRACK_N] = { "X", "Y",  "Radius" };
int track_default[TRACK_N] = { 640, 480, 3 };
int track_s[TRACK_N] = { 32, 32, 1 };
int track_e[TRACK_N] = { 2048, 2048, 7 };

#ifndef PROFILE_GPU
LPSTR check_name[] = { "CPU/GPU" };
int check_default[] = { 0 };
#else
LPSTR check_name[] = { "CPU/GPU", "AChԂɂȂ܂ő҂", "U16ɋ" };
int check_default[] = { 0, 0, 0 };
#endif

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_NO_INIT_DATA,
	0, 0,
#ifdef PROFILE_GPU
	(TCHAR*)"GPU Lanczos(Prof)",
#else
	(TCHAR*)"GPU Lanczos Resize",
#endif
	TRACK_N, (TCHAR**)track_name, track_default, track_s, track_e,
	ARRAYSIZE(check_name), (TCHAR**)check_name, check_default,
	func_proc,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL,
	NULL, 0,
	(TCHAR*)"gpu_lancx by N099, ver0.6",
	NULL, NULL,
	NULL, NULL, NULL,
};

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	SetMemDbg();
	return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//GpuFilter
	g_pGpuFilter = new(std::nothrow) GpuFilter;
	if(NULL == g_pGpuFilter){
		return FALSE;
	}

	//foCXIp
	int dev = fp->exfunc->ini_load_int(fp, "dev", 0);

	//FfoCX̍쐬s
	if(!g_pGpuFilter->Init(fp, dev)){
		SAFE_DELETE(g_pGpuFilter);
		return FALSE;
	}

#ifdef PROFILE_GPU
	//get PerformanceCounter frequency
	LARGE_INTEGER ticFreq = {0,0};
	QueryPerformanceFrequency(&ticFreq);
	if(ticFreq.QuadPart>0){
		_mm_empty();
		g_QPFreq = (double)ticFreq.QuadPart;
	}

	//create debug window
	g_debugWindow = CreateWindow(TEXT("EDIT"), TEXT("Debug GPU_LCX"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | ES_MULTILINE | ES_READONLY,
		CW_USEDEFAULT, 0,
		180, 282,
		fp->hwnd, NULL, fp->dll_hinst, NULL);
	if(g_debugWindow){
		SendMessage(g_debugWindow, WM_SETFONT, 
			(WPARAM)GetStockObject(OEM_FIXED_FONT), (LPARAM)TRUE);
	}
#endif

    //őTCY擾
    SYS_INFO si = { 0, };
    if(!fp->exfunc->get_sys_info(NULL, &si)){
        return FALSE;
    }else{
        track_s[T_X] = si.min_w;
        track_s[T_Y] = si.min_h;
		track_e[T_X] = min(si.max_w, g_pGpuFilter->GetMaxWidth());
		track_e[T_Y] = min(si.max_h, g_pGpuFilter->GetMaxHeight());
		track_e[T_RAD] = g_pGpuFilter->GetMaxRadius();
        fp->exfunc->filter_window_update(fp);
    }

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
#ifdef PROFILE_GPU
	if(g_debugWindow) DestroyWindow(g_debugWindow);
#endif

	SAFE_DELETE(g_pGpuFilter);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	static int n;

	if(!g_pGpuFilter) return FALSE;

	if(TRUE != fp->exfunc->set_ycp_filtering_cache_size(
		fp, fpip->max_w, fpip->max_h, 2, NULL))
	{
		return FALSE;
	}

#ifdef PROFILE_GPU
	//GPȔI҂
	ZeroMemory(&g_prof, sizeof(g_prof));
	g_flush = fp->check[C_FLUSH] ? true : false;
	getCount(TEXT("Init   "));
#endif

	//t[̉摜擾
	PIXEL_YC *pyc = fp->exfunc->get_ycp_filtering_cache_ex(
			fp, fpip->editp, fpip->frame, &fpip->w, &fpip->h);
	if(pyc == NULL) return FALSE;
	getCount(TEXT("CacheCur"));
#if 1
	//TCYύXȂꍇ͒PɃRs[̂
	if(fpip->w == fp->track[T_X] && fpip->h == fp->track[T_Y]){
		PIXEL_YC *dst = fpip->ycp_edit; 
		for(int i=0; i<fpip->h; ++i){
			CopyMemory(dst, pyc, fpip->w * sizeof(PIXEL_YC));
			dst += fpip->max_w;
			pyc += fpip->max_w;
		}
		return TRUE;
	}
#endif
	//TCYύX̃`FbN
	if(g_pGpuFilter->IsSizeChanged(fpip->w, fpip->h, fp->track[T_X], fp->track[T_Y])){
		g_need_realloc = true;
	}

	//foCX̏Ԃ`FbN
	if(!g_pGpuFilter->TestDeviceState(&g_need_realloc)) return FALSE;

	//p[^ύXꂽꍇ
	if(g_need_realloc){
		g_pGpuFilter->ReleaseResources();
#ifdef PROFILE_GPU
		g_pGpuFilter->AllocResources(fpip->w, fpip->h,
			fp->track[T_X], fp->track[T_Y], fpip->max_w, fp->check[C_U16]);
#else
		g_pGpuFilter->AllocResources(fpip->w, fpip->h,
			fp->track[T_X], fp->track[T_Y], fpip->max_w);
#endif
		g_pGpuFilter->SetParams(fp->track[T_RAD]);
		getCount(TEXT("AllocRes"));

		g_need_realloc = false;
		g_chg_param = false;
	}else if(g_chg_param){
		g_pGpuFilter->SetParams(fp->track[T_RAD]);
		getCount(TEXT("SetParam"));
		g_chg_param = false;
	}

	//f[^GPUɓ]
	if(!g_pGpuFilter->PutImage(pyc, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}
	getCount(TEXT("PutUnlck"));

	//GPUŏ
	n = fpip->frame - n;
	if(!fp->check[C_PARA]){
		//
		if(!g_pGpuFilter->ProcImage()) return FALSE;
		getCount(TEXT("Proc    "));
	}else{
		//񓯊
		if(!g_pGpuFilter->ProcImageAsync()) return FALSE;
		getCount(TEXT("ProcAsyn"));

		//t[LbV
		if(n){
			fp->exfunc->get_ycp_filtering_cache_ex(
				fp, fpip->editp, fpip->frame + n, NULL, NULL);
		}
		n = fpip->frame;
		getCount(TEXT("CacheNxt"));
	}

	//o̓f[^o
	if(!g_pGpuFilter->GetImage(fpip->ycp_edit, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}
	getCount(TEXT("GetUnlck"));

	//TCYZbg
	fpip->w = fp->track[T_X];
	fpip->h = fp->track[T_Y];

	printCount();

	return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐i98dΉ̂WndProcĂ΂悤ɂj
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
	g_chg_param = true;

#ifdef PROFILE_GPU
	if(g_pGpuFilter){
		if(g_pGpuFilter->GetPixelFormat() != 
			g_pGpuFilter->PixelFormatFromIndex(fp->check[C_U16]))
		{
			g_need_realloc = true;
		}
	}
#endif

	return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND h, UINT m, WPARAM w, LPARAM l, void *e, FILTER *fp)
{
	switch(m){
		case WM_COMMAND:
			switch(HIWORD(w)){
				case BN_CLICKED:
					if(LOWORD(w) == IDC_SETSIZE && g_wcmb){
						return set_rssize(g_wcmb, fp);
					}
			}
			break;
		case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽɑ܂
			if(g_pGpuFilter && !fp->exfunc->is_filter_active(fp)){
				g_pGpuFilter->ReleaseResources();
				g_need_realloc = true;
			}
			break;
		case WM_FILTER_INIT:
			return init_config_window(h, fp);
		case WM_FILTER_EXIT:
			return exit_config_window(h, fp);
		default:
			break;
	}

	return FALSE;
}

BOOL init_config_window(HWND hwnd, FILTER *fp)
{
	HWND wchk = FindWindowExA(hwnd, NULL, "BUTTON", check_name[0]);
	if(!wchk){
		return FALSE;
	}

	//`FbN{bNX̌㔼u
	RECT rcp,rcc;
	GetClientRect(hwnd, &rcp);
	GetWindowRect(wchk, &rcc);

	POINT pt = { rcc.left, rcc.top };
	ScreenToClient(hwnd, &pt);

	int px = pt.x;
	int pw = rcp.right - rcp.left;
	int height = rcc.bottom - rcc.top;
	MoveWindow(wchk, px, pt.y, pw/2, height, 1);

	const int btnw = 44;
	const int spc0 = 8;
	const int spc1 = 4;
	const int spc2 = 2;
	px += pw/2 + spc0;

	//tHg̎擾
	NONCLIENTMETRICS ncm = { sizeof(NONCLIENTMETRICS), };
#if(WINVER >= 0x0600)
	ncm.cbSize = offsetof(NONCLIENTMETRICS, iPaddedBorderWidth);
#endif /* WINVER >= 0x0600 */
	if(SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncm.cbSize, &ncm, 0)){
		g_font = CreateFontIndirect(&ncm.lfMessageFont);
	}
	if(!g_font) g_font = (HFONT)GetStockObject(DEFAULT_GUI_FONT); //fallback

	//ɈU{bNX쐬č߂
	g_wcmb = CreateWindow(TEXT("COMBOBOX"), TEXT(""),
		CBS_DROPDOWN | WS_CHILD | WS_VISIBLE,
		px + btnw + spc1,	pt.y, pw - px, height * 8,
		hwnd, NULL, fp->dll_hinst, NULL);
	if(!g_wcmb){
		return FALSE;
	}
	SendMessage(g_wcmb, CB_LIMITTEXT, 10, 0);
	SendMessage(g_wcmb, WM_SETFONT, (WPARAM)g_font, FALSE);
	
	//Xgvf̏
	init_rss_list(g_wcmb, fp);

	//GfBbg̈TuNX
	g_wedt = FindWindowEx(g_wcmb, NULL, TEXT("EDIT"), NULL);
	g_orig_cmb_edit_proc =
		(WNDPROC)SetWindowLongPtr(g_wedt, GWL_WNDPROC, (LONG_PTR)cmb_edit_proc);
	
	GetWindowRect(g_wcmb, &rcc);
	height = rcc.bottom - rcc.top;
	pt.y = rcp.bottom - height - 1; //1pix̗]T

	g_wbtn = CreateWindow(TEXT("BUTTON"), TEXT("set->"),
		WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
		px, pt.y + 1, btnw, height - 2,
		hwnd, (HMENU)IDC_SETSIZE, fp->dll_hinst, NULL);
	if(!g_wbtn){
		return FALSE;
	}
	SendMessage(g_wbtn, WM_SETFONT, (WPARAM)g_font, TRUE);
	px += btnw + spc1;

	//R{{bNXړ
	MoveWindow(g_wcmb, px, pt.y, pw - px - spc2, height, 1);
			
	return TRUE;
}

BOOL exit_config_window(HWND hwnd, FILTER *fp)
{
	if(g_wedt && g_orig_cmb_edit_proc){
		SetWindowLongPtr(g_wedt, GWL_WNDPROC, (LONG_PTR)g_orig_cmb_edit_proc);
	}

	if(g_wcmb){
		save_rss_list(g_wcmb, fp);
	}

	if(g_font){
		DeleteObject(g_font);
	}

	//clear
	g_wbtn = g_wcmb = g_wedt = NULL;
	g_orig_cmb_edit_proc = NULL;
	g_font = NULL;

	return TRUE;
}

BOOL set_rssize(HWND hwcmb, FILTER *fp)
{
	int x = 0, y = 0;
	LRESULT idx = SendMessage(hwcmb, CB_GETCURSEL, 0, 0);
	if(idx != CB_ERR){ //Iς
		LRESULT r = SendMessage(hwcmb, CB_GETITEMDATA, idx, 0);
		if(r != CB_ERR){
			x = LOWORD(r);
			y = HIWORD(r);
		}
	}else{ //I
		POINT pt = get_edit_rssize(hwcmb);
		if(pt.x && pt.y){
			x = pt.x;
			y = pt.y;
			ins_cmb_list(hwcmb, x, y, true);
		}
	}

	if(x && y){
		//TCYZbg
		fp->track[T_X] = min(max(fp->track_s[T_X], x), fp->track_e[T_X]);
		fp->track[T_Y] = min(max(fp->track_s[T_Y], y), fp->track_e[T_Y]);
		return fp->exfunc->filter_window_update(fp);
	}else{
		return FALSE;
	}
}

POINT get_edit_rssize(HWND hwcmb)
{
	TCHAR buf[64];
	LRESULT l = SendMessage(hwcmb, WM_GETTEXT, ARRAYSIZE(buf), (LPARAM)buf); 
	buf[l] = TEXT('\0');

	for(int i=0; i<l; ++i){
		if(!_istdigit(buf[i])) buf[i] = TEXT(' ');
	}
	
	int x,y;
	if(2 == _stscanf_s(buf, TEXT("%d %d"), &x, &y)){
		//Nbv
		x = max(min(x, 9999), 32);
		y = max(min(y, 9999), 32);
		//\̍XV
		StringCchPrintf(buf, ARRAYSIZE(buf), TEXT("%dx%d"), x, y);
		SendMessage(hwcmb, WM_SETTEXT, 0, (LPARAM)buf); 
	}else{
		x = y = 0;
	}

	POINT ret = { x, y };
	return ret;
}

void ins_cmb_list(HWND hwcmb, int x, int y, bool sel)
{
	TCHAR buf[64];
	LRESULT lr;

	StringCchPrintf(buf, ARRAYSIZE(buf), TEXT("%dx%d"), x, y);

	//܂݂Ȃꍇǉ
	lr = SendMessage(hwcmb, CB_FINDSTRING, (WPARAM)-1, (LPARAM)buf);
	if(CB_ERR == lr){
		//𒴂ꍇ͈폜
		LRESULT cnt = SendMessage(hwcmb, CB_GETCOUNT, 0, 0);
		if(cnt >= NUM_RSZ_MAX){
			SendMessage(hwcmb, CB_DELETESTRING, 0, 0);
		}

		lr = SendMessage(hwcmb, CB_ADDSTRING, 0, (LPARAM)buf);
		if(lr != CB_ERR && lr != CB_ERRSPACE){
			SendMessage(hwcmb, CB_SETITEMDATA, lr, (LPARAM)MAKELONG(x, y));
		}
	}

	//vꂽꍇ͑I
	if(sel && CB_ERR != lr){
		SendMessage(hwcmb, CB_SETCURSEL, lr, 0);
	}
}

void init_rss_list(HWND hwcmb, FILTER *fp)
{
	int i;
	char buf[64];

	for(i=0; i<NUM_RSZ_MAX; ++i){
		StringCbPrintfA(buf, sizeof(buf), "size_%02d", i);
		int c = fp->exfunc->ini_load_int(fp, buf, 0);
		if(c == 0){
			break;
		}
		
		//f[^}
		int d = abs(c);
		ins_cmb_list(hwcmb, LOWORD(d), HIWORD(d), c < 0);
	}

	if(i == 0){ //ݒ肪̏ꍇ
		ins_cmb_list(hwcmb, 640, 480, true);
	}
}

void save_rss_list(HWND hwcmb, FILTER *fp)
{
	char buf[64];
	LRESULT cnt = SendMessage(hwcmb, CB_GETCOUNT, 0, 0);
	LRESULT sel = SendMessage(hwcmb, CB_GETCURSEL, 0, 0);

	for(int i=0; i<NUM_RSZ_MAX && i<cnt; ++i){
		StringCbPrintfA(buf, sizeof(buf), "size_%02d", i);
		LRESULT r = SendMessage(hwcmb, CB_GETITEMDATA, i, 0);
		fp->exfunc->ini_save_int(fp, buf, (i==sel) ? -r : r);
	}
}

LRESULT CALLBACK cmb_edit_proc(HWND h, UINT m, WPARAM w, LPARAM l)
{
	switch(m){
		case WM_CHAR:
			if(w == VK_RETURN){
				SendMessage(g_wbtn, BM_CLICK, 0, 0);
				return 0;
			}else if(w >= '0' && w <= '9'){
			}else if(w == 'x' || w == '*'){
			}else if(!isgraph(w)){
			}else{
				MessageBeep((UINT)-1);
				return 0;
			}
			break;
		default:
			break;
	}

	return CallWindowProc(g_orig_cmb_edit_proc, h, m, w, l); 
}

//ptH[}Xp
#ifdef PROFILE_GPU
void getCount(const TCHAR *tag)
{
	if(g_flush){
		g_pGpuFilter->WaitForIdle();
	}
	QueryPerformanceCounter(&g_prof.pc[g_prof.i].c);
	StringCbCopy(g_prof.pc[g_prof.i].s, sizeof(g_prof.pc[g_prof.i].s), tag);
	g_prof.i++;
}

void printCount()
{
	TCHAR buf[512];
	TCHAR buf0[64];
	const TCHAR *fmt = TEXT("?");
	double ticks,rQPF;
	int h,w;

	_mm_empty();

	if(NULL == g_debugWindow) return;
	if(g_pGpuFilter){
		h = g_pGpuFilter->GetHeight();
		w = g_pGpuFilter->GetWidth();
		fmt = g_pGpuFilter->GetPixelFormatStr();
	}else{
		h = w = 0;
	}

	rQPF = 1.0 / g_QPFreq;
#if 0
	StringCchPrintf(buf, 512,
		TEXT("Size :%dx%d(%s)\r\nQPF  :%.5E\r\n"), w,h, fmt, g_QPFreq);
#else
	StringCchPrintf(buf, 512, TEXT("Size :%dx%d(%s)\r\n"), w,h, fmt);
#endif
	for(int i=1; i<g_prof.i; ++i){
		ticks = (double)(g_prof.pc[i].c.QuadPart - g_prof.pc[i-1].c.QuadPart) * rQPF;
		StringCchPrintf(buf0, 64, TEXT("%s:%.5E\r\n"), g_prof.pc[i].s, ticks);
		StringCbCat(buf, sizeof(buf), buf0);
	}

	//All
	ticks = (double)(g_prof.pc[g_prof.i - 1].c.QuadPart - g_prof.pc[0].c.QuadPart) * rQPF;
	StringCchPrintf(buf0, 64, TEXT("%s:%.5E\r\n"), TEXT("All     "), ticks);
	StringCbCat(buf, sizeof(buf), buf0);

	SendMessage(g_debugWindow, WM_SETTEXT, 0, (LPARAM)buf);  
}
#endif

#ifdef _DEBUG
void SetMemDbg()
{
	int tmpFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	tmpFlag |= _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF;
	_CrtSetDbgFlag( tmpFlag );
}
#endif
