//----------------------------------------------------------------------------------
// aviutl  GPU Lanczos TCYtB^
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#pragma once

//p[^`Ȃ
enum EFFECT_PARAM { PARAM_RAD, PARAM_REP, PARAM_SSZ, PARAM_MRT, PARAM_N };
enum EFFECT_TEX { TEX_WEIGHT, TEX_SOURCE, TEX_N };
enum EFFECT_PASS { MIN_X, MAG_X, MIN_Y, MAG_Y };

//D3DX֐
typedef HRESULT (WINAPI * CREATEEFFECT)(LPDIRECT3DDEVICE9, LPCVOID, UINT,
										CONST D3DXMACRO*, LPD3DXINCLUDE,
										DWORD, LPD3DXEFFECTPOOL,
										LPD3DXEFFECT*, LPD3DXBUFFER*);

//MT
typedef BOOL (__cdecl * EXEC_MT)(MULTI_THREAD_FUNC, void*, void*);
typedef void (* YC_I16)(BYTE*, const PIXEL_YC*, unsigned int);
typedef void (* I16_YC)(PIXEL_YC*, const BYTE*, unsigned int);
class ThrProc;

//_Ci~bNeNX`ixグ邽߂ɂ͎gȂǂj
#define USE_DYNAMIC_TEXTURE

//GPUtB^NX
class GpuFilter
{
public:
	enum PIXEL_FORMAT { S16 = 0, U16, Unknown };

private:
	IDirect3D9 *m_pD3D; //IDirect3D9IuWFNg
	IDirect3DDevice9 *m_pd3dDevice; //D3DfoCX

	//foCX̃T[tFX
	IDirect3DTexture9 *m_pTexWeight; //dݗpeNX`
	IDirect3DTexture9 *m_pTexSrc;    //f[^peNX`
	IDirect3DTexture9 *m_pTexRt;     //ԌʗpRTeNX`
	IDirect3DSurface9 *m_pSrfRt;     //ŏIo͗pRTT[tFX

	//VXẽT[tFX
	IDirect3DTexture9 *m_pTexWeightTmp; //d݂̃Rs[p
	IDirect3DTexture9 *m_pTexSysSrc;    //Rs[ɗpeNX`(src)
	IDirect3DTexture9 *m_pTexSysDst;    //Rs[ɗpeNX`(dst)
	
	IDirect3DVertexBuffer9 *m_pVert; //`p_
	IDirect3DVertexDeclaration9 *m_pVertDec; //`p_錾

	ID3DXEffect *m_pEffect; //GtFNg
	IDirect3DQuery9* m_pQuery;

	//p[^
	D3DXHANDLE m_hParam[PARAM_N];
	D3DXHANDLE m_hTec;
	D3DXHANDLE m_hTex[TEX_N];

	//摜TCY
	int m_wSrc;
	int m_hSrc;
	int m_wItm;
	int m_hItm;
	int m_wDst;
	int m_hDst;
	int m_pycStride;
	int m_wMax;
	int m_hMax;

	//sNZtH[}bg
	PIXEL_FORMAT m_pixFormat;
	bool m_pixFormatAvailable[Unknown];

	//pXI
	int m_pass[2];

	//񏈗pXbh
	ThrProc *m_tproc;

	//D3DXCu
	HMODULE m_hD3dxdll;
	CREATEEFFECT m_pCreateEffect;

public:
	GpuFilter();
	~GpuFilter();

	bool Init(FILTER *fp, int dev = 0);
	bool Release();
	bool AllocResources(int w0, int h0, int w1, int h1, int w_max, int fmt = S16);
	bool ReleaseResources();
	bool SetParams(int r);
	bool TestDeviceState(bool *need_realloc);
	bool PutImage(const PIXEL_YC *data, EXEC_MT func_mt);
	bool ProcImage(int empty = 0);
	bool ProcImageAsync();
	bool GetImage(PIXEL_YC *data, EXEC_MT func_mt);

	bool IsSizeChanged(int w0, int h0, int w1, int h1) const
	{ return (w0 != m_wSrc) || (h0 != m_hSrc) || (w1 != m_wDst) || (h1 != m_hDst); }
	int GetWidth() const { return m_wDst; }
	int GetHeight() const { return m_hDst; }
	int GetMaxWidth() const { return m_wMax; }
	int GetMaxHeight() const { return m_hMax; }
	int GetMaxRadius() const;
	PIXEL_FORMAT GetPixelFormat(void) const { return m_pixFormat; }
	const TCHAR *GetPixelFormatStr(void) const;
	PIXEL_FORMAT PixelFormatFromIndex(int i) const
	{ return (PIXEL_FORMAT)((i<0) ? 0 : ((i>Unknown) ? Unknown : i)); }
#ifdef PROFILE_GPU
	void WaitForIdle();
#endif
private:
	HRESULT LoadD3DXFunc();
	HRESULT CheckDeviceCap();
	HRESULT CreateEffect();
	HRESULT CreateVert();
	HRESULT CreateTexture(IDirect3DTexture9 **ppTex, DWORD usage, D3DPOOL pool, UINT w, UINT h);
	HRESULT CreateSurface(IDirect3DSurface9 **ppSrf, DWORD usage, D3DPOOL pool, UINT w, UINT h);
	HRESULT CreateSysMemResources();
	HRESULT CreateDefaultResources();
	HRESULT SetEffectResources();
	HRESULT Reset();
	HRESULT PutPixelData(IDirect3DTexture9 *sys, const PIXEL_YC *src, EXEC_MT func_mt);
	HRESULT PutPixelDataDT(IDirect3DTexture9 *dst, const PIXEL_YC *src, EXEC_MT func_mt);
	HRESULT GetRenderTargetData();
	HRESULT GetPixelData(PIXEL_YC *dst, IDirect3DTexture9 *sys, EXEC_MT func_mt);
	HRESULT ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg);

	HRESULT UpdateSurface(IDirect3DSurface9 *src, IDirect3DTexture9 *dst);
	HRESULT SetRenderTarget(IDirect3DTexture9 *dst);
	HRESULT SetRenderTarget(IDirect3DSurface9 *dst);
	HRESULT SetPixelFmt(PIXEL_FORMAT fmt);
	HRESULT CheckRtTexFormat(UINT ad, D3DDEVTYPE dt, D3DFORMAT af, D3DFORMAT tgt) const;

	void ReleaseDefaultResources();
	void SetIntermediateSize();
	void SelectPasses();
	D3DFORMAT PicFmtToD3DFmt(PIXEL_FORMAT p) const;
	static void __cdecl AsyncProc(void *param);

#ifdef PROFILE_GPU
	HRESULT CreateQuery();
#endif
};

//---------------------------------------------------------------------
// macro
//---------------------------------------------------------------------
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#endif
